grails-app/controllers/LiteratureController.groovy
/**
 * $Id: LiteratureController.groovy 10133 2011-10-20 21:34:43Z mmcduffie $
 * @author $Author: mmcduffie $
 * @version $Revision: 10133 $
 */
import com.recomdata.util.ExcelGenerator
import com.recomdata.util.ExcelSheet
import com.recomdata.util.ariadne.Batch
import grails.converters.JSON
import org.transmart.SearchResult
import org.transmart.searchapp.AccessLog

import javax.xml.bind.JAXBContext
import javax.xml.bind.Marshaller

class LiteratureController {

    def literatureQueryService
    def trialQueryService
    def jubilantResNetService
    def searchService
    def springSecurityService

    def index = {

    }

    def showJubFilter = {
        def model = [:]
        model.disease = literatureQueryService.diseaseList(session.searchFilter)
        model.diseaseSite = literatureQueryService.diseaseSiteList(session.searchFilter)
        model.component = literatureQueryService.componentList(session.searchFilter)
        model.mutationType = literatureQueryService.mutationTypeList(session.searchFilter)
        model.mutationSite = literatureQueryService.mutationSiteList(session.searchFilter)
        model.epigeneticType = literatureQueryService.epigeneticTypeList(session.searchFilter)
        model.epigeneticRegion = literatureQueryService.epigeneticRegionList(session.searchFilter)
        model.moleculeType = literatureQueryService.moleculeTypeList(session.searchFilter)
        model.ptmType = literatureQueryService.ptmTypeList(session.searchFilter)
        model.ptmRegion = literatureQueryService.ptmRegionList(session.searchFilter)
        model.source = literatureQueryService.sourceList(session.searchFilter)
        model.target = literatureQueryService.targetList(session.searchFilter)
        model.experimentalModel = literatureQueryService.experimentalModelList(session.searchFilter)
        model.mechanism = literatureQueryService.mechanismList(session.searchFilter)
        model.trialType = literatureQueryService.trialTypeList(session.searchFilter)
        model.trialPhase = literatureQueryService.trialPhaseList(session.searchFilter)
        model.inhibitorName = literatureQueryService.inhibitorNameList(session.searchFilter)
        model.trialExperimentalModel = literatureQueryService.trialExperimentalModelList(session.searchFilter)
        render(template: 'litFilter', model: model)
    }

    def getJubOncologyAlterationDetail = {
        def id = params?.id
        def result = [:]
        if (id != null) {
            result = LiteratureAlterationData.get(Long.valueOf(id))
        }
        render(template: 'litDetail', model: [result: result])
    }

    def getJubOncologyInhibitorDetail = {
        def id = params?.id
        def result = [:]
        if (id != null) {
            result = LiteratureInhibitorData.get(Long.valueOf(id))
        }
        render(template: 'litDetail', model: [result: result])
    }

    def getJubOncologyInteractionDetail = {
        def id = params?.id
        def result = [:]
        if (id != null) {
            result = LiteratureInteractionData.get(Long.valueOf(id))
        }
        render(template: 'litDetail', model: [result: result])
    }

    def filterJubilant = {
        def searchFilter = session.searchFilter
        bindData(searchFilter.litFilter, params)
        searchFilter.litFilter.parseDiseaseSite(params?.diseaseSite)
        searchFilter.litFilter.parseComponentList(params?.componentList)
        for (alterationType in searchFilter.litFilter.alterationTypes.keySet()) {
            searchFilter.litFilter.alterationTypes.put(alterationType, "on".equals(params.get("alterationtype_" + alterationType.toLowerCase().replace(" ", "_"))))
        }
        searchFilter.datasource = "literature"
        def sResult = new SearchResult()
        searchService.doResultCount(sResult, searchFilter)
        render(view: '/search/list', model: [searchresult: sResult])
    }

    def datasourceJubilant = {
        def datatype = params?.datatype // != null ? params.datatype : "JUBILANT_ONCOLOGY_ALTERATION"
        def searchFilter = session.searchFilter
        def sResult = new SearchResult()
        sResult.litJubOncAltCount = literatureQueryService.litJubOncAltCount(searchFilter)
        if (datatype == null && sResult.litJubOncAltCount > 0) {
            datatype = "JUBILANT_ONCOLOGY_ALTERATION"
        }
        sResult.litJubOncInhCount = literatureQueryService.litJubOncInhCount(searchFilter)
        if (datatype == null && sResult.litJubOncInhCount > 0) {
            datatype = "JUBILANT_ONCOLOGY_INHIBITOR"
        }
        sResult.litJubOncIntCount = literatureQueryService.litJubOncIntCount(searchFilter)
        if (datatype == null && sResult.litJubOncIntCount > 0) {
            datatype = "JUBILANT_ONCOLOGY_INTERACTION"
        }
        sResult.litJubAsthmaAltCount = literatureQueryService.litJubAsthmaAltCount(searchFilter)
        if (datatype == null && sResult.litJubAsthmaAltCount > 0) {
            datatype = "JUBILANT_ASTHMA_ALTERATION"
        }
        sResult.litJubAsthmaInhCount = literatureQueryService.litJubAsthmaInhCount(searchFilter)
        if (datatype == null && sResult.litJubAsthmaInhCount > 0) {
            datatype = "JUBILANT_ASTHMA_INHIBITOR"
        }
        sResult.litJubAsthmaIntCount = literatureQueryService.litJubAsthmaIntCount(searchFilter)
        if (datatype == null && sResult.litJubAsthmaIntCount > 0) {
            datatype = "JUBILANT_ASTHMA_INTERACTION"
        }
        sResult.litJubAsthmaPECount = literatureQueryService.litJubAsthmaPECount(searchFilter)
        if (datatype == null && sResult.litJubAsthmaPECount > 0) {
            datatype = "JUBILANT_ASTHMA_PROTEIN_EFFECT"
        }
        sResult.resultType = datatype
        switch (datatype) {
            case "JUBILANT_ONCOLOGY_ALTERATION":
                sResult.resultCount = sResult.litJubOncAltCount
                sResult.result = literatureQueryService.litJubOncAltData(searchFilter, params)
                break
            case "JUBILANT_ONCOLOGY_INHIBITOR":
                sResult.resultCount = sResult.litJubOncInhCount
                sResult.result = literatureQueryService.litJubOncInhData(searchFilter, params)
                break
            case "JUBILANT_ONCOLOGY_INTERACTION":
                sResult.resultCount = sResult.litJubOncIntCount
                sResult.result = literatureQueryService.litJubOncIntData(searchFilter, params)
                break
            case "JUBILANT_ASTHMA_ALTERATION":
                sResult.resultCount = sResult.litJubAsthmaAltCount
                sResult.result = literatureQueryService.litJubAsthmaAltData(searchFilter, params)
                break
            case "JUBILANT_ASTHMA_INHIBITOR":
                sResult.resultCount = sResult.litJubAsthmaInhCount
                sResult.result = literatureQueryService.litJubAsthmaInhData(searchFilter, params)
                break
            case "JUBILANT_ASTHMA_INTERACTION":
                sResult.resultCount = sResult.litJubAsthmaIntCount
                sResult.result = literatureQueryService.litJubAsthmaIntData(searchFilter, params)
                break
            case "JUBILANT_ASTHMA_PROTEIN_EFFECT":
                sResult.resultCount = sResult.litJubAsthmaPECount
                sResult.result = literatureQueryService.litJubAsthmaPEData(searchFilter, params)
                break
        }
        render(template: 'litResult', model: [searchresult: sResult])
    }
/*
	def datasourceJubOncologyAlteration = {
		def searchFilter = session.searchFilter
		def sResult = new SearchResult()
		sResult.litJubOncAltCount = literatureQueryService.litJubOncAltCount(session.searchFilter)
		sResult.result = literatureQueryService.litJubOncAltData(searchFilter, params)
		render(template:'LiteratureAlterationData', model:[searchresult:sResult])
	}

	def datasourceJubOncologyInhibitor = {
		def searchFilter = session.searchFilter
		def sResult = new SearchResult()
		sResult.result = literatureQueryService.litJubOncInhData(searchFilter, params)
		render(template:'LiteratureInhibitorData', model:[searchresult:sResult])
	}

	def datasourceJubOncologyInteraction = {
		def searchFilter = session.searchFilter
		def sResult = new SearchResult()
		sResult.result = literatureQueryService.litJubOncIntData(searchFilter, params)
		render(template:'LiteratureInteractionData', model:[searchresult:sResult])
	}
*/

    def createJubSummary = {

        def searchFilter = session.searchFilter
        def resultCount
        def result
        resultCount = literatureQueryService.litJubOncAltSumCount(searchFilter)
        result = literatureQueryService.litJubOncAltSumData(searchFilter, params)
        def rows = []
        for (summary in result) {
            def values = [dataType          : summary.dataType,
                          alterationType    : summary.alterationType,
                          totalFrequency    : summary.totalFrequency,
                          totalAffectedCases: summary.totalAffectedCases,
                          summary           : summary.summary,
                          target            : summary.target,
                          variant           : summary.variant,
                          diseaseSite       : summary.diseaseSite]
            rows.add(values)
        }

        return [count: resultCount, rows: rows]

    }

    def jubSummaryJSON = {
        def result = createJubSummary()
        render params.callback + "(" + (result as JSON) + ")"
    }

    static List litRefDataColumns = [
            "component",
            "componentClass",
            "geneId",
            "moleculeType",
            "variant",
            "referenceType",
            "referenceId",
            "referenceTitle",
            "backReferences",
            "studyType",
            "disease",
            "diseaseIcd10",
            "diseaseMesh",
            "diseaseSite",
            "diseaseStage",
            "diseaseGrade",

grails-app/views/literature/_litResult.gsp
<!-- loading image -->
<g:waitIndicator divId="jubresult_loading"/>

<div id="jubresult" style="display: block;">
<g:if test="${searchresult?.literatureCount() > 0}">
    <table style="padding:10px 5px 0px 5px;">
        <tr>
            <td>
                <table>
                    <tr><td style="line-height: 13px;"><b>Jubilant Oncology (${searchresult?.litJubOncCount()})</b>
                    </td></tr>
                    <tr><td style="padding:2px 0px 0px 20px;">Alterations (${searchresult?.litJubOncAltCount})</td>
                    </tr>
                    <tr><td style="padding:2px 0px 0px 20px;">Inhibitors (${searchresult?.litJubOncInhCount})</td>
                    </tr>
                    <tr><td style="padding:2px 0px 0px 20px;">Interactions (${searchresult?.litJubOncIntCount})</td>
                    </tr>
                </table>
            </td>
            <td>
                <table>
                    <tr><td><b>Jubilant Asthma (${searchresult?.litJubAsthmaCount()})</b>
                    </td></tr>
                    <tr><td style="padding:2px 0px 0px 20px;">Alterations (${searchresult?.litJubAsthmaAltCount})</td>
                    </tr>
                    <tr><td style="padding:2px 0px 0px 20px;">Interactions (${searchresult?.litJubAsthmaIntCount})</td>
                    </tr>
                    <tr><td style="padding:2px 0px 0px 20px;">Protein Effects (${searchresult?.litJubAsthmaPECount})</td>
                    </tr>
                </table>
            </td>
            <td width="50%">&nbsp;</td>
        </tr>
    </table>

    <div class="paginateButtons" style="width: 100%;">
        <span style="font-size:12px;color:#000000;">Results for</span>
        <select class="jubselect" name="resultType" id="resultType"
                style="width:240px;"
                onChange="${remoteFunction(action: 'datasourceJubilant',
                        before: 'toggleVisible(\'jubresult_loading\'); toggleVisible(\'jubresult\');',
                        onComplete: 'toggleVisible(\'jubresult_loading\'); toggleVisible(\'jubresult\');',
                        update: 'jubresult', params: '\'datatype=\'+this.value')}">
            <g:if test="${searchresult?.litJubOncAltCount > 0}">
                <option value="JUBILANT_ONCOLOGY_ALTERATION" ${searchresult.resultType == null || searchresult.resultType == 'JUBILANT_ONCOLOGY_ALTERATION' ? "selected" : ""}>Jubilant Oncology Alterations</option>
            </g:if>
            <g:if test="${searchresult?.litJubOncInhCount > 0}">
                <option value="JUBILANT_ONCOLOGY_INHIBITOR" ${searchresult.resultType == 'JUBILANT_ONCOLOGY_INHIBITOR' ? "selected" : ""}>Jubilant Oncology Inhibitors</option>
            </g:if>
            <g:if test="${searchresult?.litJubOncIntCount > 0}">
                <option value="JUBILANT_ONCOLOGY_INTERACTION" ${searchresult.resultType == 'JUBILANT_ONCOLOGY_INTERACTION' ? "selected" : ""}>Jubilant Oncology Interactions</option>
            </g:if>
            <g:if test="${searchresult?.litJubAsthmaAltCount > 0}">
                <option value="JUBILANT_ASTHMA_ALTERATION" ${searchresult.resultType == 'JUBILANT_ASTHMA_ALTERATION' ? "selected" : ""}>Jubilant Asthma Alterations</option>
            </g:if>
            <g:if test="${searchresult?.litJubAsthmaInhCount > 0}">
                <option value="JUBILANT_ASTHMA_INHIBITOR" ${searchresult.resultType == 'JUBILANT_ASTHMA_INHIBITOR' ? "selected" : ""}>Jubilant Asthma Inhibitors</option>
            </g:if>
            <g:if test="${searchresult?.litJubAsthmaIntCount > 0}">
                <option value="JUBILANT_ASTHMA_INTERACTION" ${searchresult.resultType == 'JUBILANT_ASTHMA_INTERACTION' ? "selected" : ""}>Jubilant Asthma Interactions</option>
            </g:if>
            <g:if test="${searchresult?.litJubAsthmaPECount > 0}">
                <option value="JUBILANT_ASTHMA_PROTEIN_EFFECT" ${searchresult.resultType == 'JUBILANT_ASTHMA_PROTEIN_EFFECT' ? "selected" : ""}>Jubilant Asthma Protein Effects</option>
            </g:if>
        </select>
        &nbsp;&nbsp;
        <g:remotePaginate update="jubresult"
                          total="${searchresult.resultCount}"
                          controller="literature"
                          action="datasourceJubilant"
                          params="[datatype: searchresult.resultType]"
                          maxsteps="${grailsApplication.config.com.recomdata.search.paginate.maxsteps}"
                          max="${grailsApplication.config.com.recomdata.search.paginate.max}"/>
    </div>
    <table width="100%">
        <g:if test="${searchresult.result?.size() > 0}">
            <g:each in="${searchresult.result}" status="i" var="jubData">
                <g:set var="jubrifdivid" value="jubrif_${jubData.id}"/>
                <tr class="${(i % 2) == 0 ? 'odd' : 'even'}">
                    <td colspan="2">
                        <table class="rnoborder" width="100%">
                            <tr>
                                <td align="left">
                                    <div style="float:none;">
                                        <a onclick="toggleDetail('${jubrifdivid}')">
                                            <div id="${jubrifdivid}_fclose"
                                                 style="visibility:hidden; display:none;width:16px;">
                                                <img src="${resource(dir: 'images', file: 'folder-minus.gif')}"
                                                     style="vertical-align:middle;"/>
                                            </div>

                                            <div id="${jubrifdivid}_fopen"
                                                 style="display:inline;width:16px;">
                                                <img src="${resource(dir: 'images', file: 'folder-plus.gif')}"
                                                     style="vertical-align:middle;"/>
                                            </div>
                                            <g:if test="${jubData.reference.referenceTitle?.length() > 0}">
                                                <g:set var="descr"
                                                       value="${jubData.reference.referenceTitle}"/>
                                                <b>${(descr?.length() > 180) ? descr.substring(0, 180) + "..." : descr}</b>
                                            </g:if>
                                        <!-- TODO? geneProteinVariant: Inhibitor Studies -->
                                        </a>
                                    </div>
                                </td>
                                <td width="15%" align="right">
                                <!-- TODO: Add link to associated articles -->
                                    <g:if test="${jubData.files.size() > 0}">
                                        <g:each in="${jubData.files}"
                                                status="fileCount"
                                                var="file">
                                            <g:if test="${fileCount > 0}">,</g:if>
                                            <g:createFileLink
                                                    content="${file.content}"
                                                    displayLabel="Reference"/>
                                        </g:each>
                                    </g:if>
                                    <g:else>
                                        <g:if test="${jubData.reference.referenceId != null && jubData.reference.referenceId != ''}">
                                            <g:if test="${jubData.reference.referenceId?.startsWith('NCT')}">
                                                <a style="border: none;"
                                                   href="http://www.clinicaltrials.gov/ct2/show/${jubData.reference.referenceId}"
                                                   target="_blank"
                                                   title="Clinical Trials"><img
                                                        alt="CT"
                                                        src="${resource(dir: 'images', file: 'clinicaltrials.png')}"/>&nbsp;Reference
                                                </a>
                                            </g:if>
                                            <g:elseif
                                                    test="${jubData.reference.referenceId?.startsWith('ISRCTN')}">
                                                <a style="border: none;"
                                                   href="http://www.controlled-trials.com/${jubData.reference.referenceId}"
                                                   target="_blank"
                                                   title="Controlled Trials"><img
                                                        alt="ISRCTN"
                                                        src="${resource(dir: 'images', file: 'controlledtrials.png')}"/>&nbsp;Reference
                                                </a>
                                            </g:elseif>
                                            <g:else>
                                                <a style="border: none;"
                                                   href="http://www.ncbi.nlm.nih.gov/pubmed/${jubData.reference.referenceId}"
                                                   target="_blank"
                                                   title="PubMed ID"><img
                                                        alt="PubMed"
                                                        src="${resource(dir: 'images', file: 'ncbi.png')}"/>&nbsp;Reference
                                                </a>
                                            </g:else>
                                        </g:if>
                                    </g:else>
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2">
                                    <span style="white-space:nowrap">
                                        <g:if test="${jubData.reference.component?.length() > 0}">
                                            <b>Variant: ${jubData.reference.component}</b>&nbsp;&nbsp;|
                                        </g:if>
                                        <g:if test="${jubData.reference.geneId?.length() > 0}">
                                            &nbsp;<b
                                                class="filter-item filter-item-gene">Gene:</b> ${createFilterDetailsLink(altId: jubData.reference.geneId, label: jubData.reference.component, type: "gene")}&nbsp;&nbsp;|
                                        </g:if>
                                        <g:if test="${jubData.reference.moleculeType?.length() > 0}">
                                            &nbsp;<b>Molecule:</b> ${jubData.reference.moleculeType}&nbsp;&nbsp;|
                                        </g:if>
                                        <g:if test="${jubData.reference.disease?.length() > 0}">
                                            &nbsp;<b
                                                class="filter-item filter-item-disease">Disease:</b> ${createFilterDetailsLink(altId: jubData.reference.disease, label: jubData.reference.disease, type: "disease")}&nbsp;&nbsp;|
                                        </g:if>
                                        <g:if test="${jubData.reference.diseaseSite?.length() > 0}">
                                            &nbsp;<b>Disease Site:</b> ${jubData.reference.diseaseSite}
                                        </g:if>
                                    </span>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td colspan=3>
                        <div id="${jubrifdivid}_detail" class="gtb1"
                             style="display:none;">
                            <g:render template="litDetail"
                                      model="[jubData: jubData, resultType: searchresult.resultType]"/>
                        </div>
                    </td>
                </tr>
            </g:each>
        </g:if>
        <g:else>
            <tr>
                <td style="padding: 10px 0px 10px 0px;font-weight:bold;text-align:center;">No Results Found</td>
            </tr>
        </g:else>
    </table>
</g:if>
<g:else>
    <br><br><br>
    <table class="snoborder" width="100%">
        <tbody>
        <tr>
            <td width="100%"
                style="text-align: center; font-size: 14px; font-weight: bold">No results found</td>
        </tr>
        </tbody>
    </table>
</g:else>
</div>

grails-app/views/literature/_noResult.gsp
<table class="snoborder" width="100%">
    <tr>
        <td width="100%" style="text-align: center; font-size: 14px; font-weight: bold">No results found</td>
    </tr>
</table>

grails-app/views/literature/_targetSummaryList.gsp
<g:if test="${data == null || data.size() == 0}">
    <br><br><br>
    <table class="snoborder" width="100%">
        <tr>
            <td width="100%" style="text-align: center; font-size: 14px; font-weight: bold">No results found</td>
        </tr>
    </table>
</g:if>
<g:else>
    <div id="jubilant-summary-grid"></div>
</g:else>